# coding: utf-8

"""
    Orbit Extrapolation API

    Orbit Extrapolation API

    The version of the OpenAPI document: 1.1.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class OemRequest(BaseModel):
    """
    Configuration parameters for exporting a CCSDS Orbit Ephemeris Message (OEM) file
    """ # noqa: E501
    file_format: Optional[StrictStr] = Field(default='KVN', alias="fileFormat")
    write_acceleration: Optional[StrictBool] = Field(default=False, description="If true the acceleration is written", alias="writeAcceleration")
    write_covariance: Optional[StrictBool] = Field(default=False, description="If true the covariance matrix is written. Not available for tle extrapolation", alias="writeCovariance")
    object_name: Optional[StrictStr] = Field(default=None, description="Spacecraft name for which orbit state data is provided", alias="objectName")
    object_id: Optional[StrictStr] = Field(default=None, description="Object identifier of the object for which orbit state data is provided", alias="objectId")
    creator: Optional[StrictStr] = Field(default=None, description="Creating agency or operator")
    __properties: ClassVar[List[str]] = ["fileFormat", "writeAcceleration", "writeCovariance", "objectName", "objectId", "creator"]

    @field_validator('file_format')
    def file_format_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['XML', 'KVN']):
            raise ValueError("must be one of enum values ('XML', 'KVN')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OemRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OemRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "fileFormat": obj.get("fileFormat") if obj.get("fileFormat") is not None else 'KVN',
            "writeAcceleration": obj.get("writeAcceleration") if obj.get("writeAcceleration") is not None else False,
            "writeCovariance": obj.get("writeCovariance") if obj.get("writeCovariance") is not None else False,
            "objectName": obj.get("objectName"),
            "objectId": obj.get("objectId"),
            "creator": obj.get("creator")
        })
        return _obj


